package com.test.task;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.jboss.logging.Logger;
import org.kie.api.task.UserGroupCallback;


public class CustomTestUserGroupCallbackImpl  implements UserGroupCallback {

    private static final Logger LOGGER = Logger.getLogger(CustomTestUserGroupCallbackImpl.class.getName());
    
	// no no-arg constructor to prevent cdi from auto deploy
	public CustomTestUserGroupCallbackImpl(boolean activate) {
		LOGGER.info("CustomTestUserGroupCallbackImpl # construbtor is called Impl obj created...");
	}


	List<String> groupList = Arrays.asList("admin", "analyst"); 
	
	// in BPMS, add 2 users: bpmsAdmin & root
	// According to the support case description 01165041:
	
	// [However while checking exists user functionality 
	// I remove root from the list and provide authorization to only jbpmwasAdmin.
	// List<String> userList = Arrays.asList("jbpmwasAdmin");]
	
	// "root" is filtered out here, so actually existsUser() returns false for user "root"
	List<String> userList = Arrays.asList("bpmsAdmin");
	
	

	@Override
	public boolean existsGroup(String groupId) {
		LOGGER.info("CustomTestUserGroupCallbackImpl # existsGroup() is called, group:"+groupId);
		boolean retVal = false;
		
		if (groupId != null && !groupId.trim().equals("")) {
			for (String str: groupList) {
				if (str.trim().contains(groupId)){
					retVal = true;
				}
			}
		}
		LOGGER.info("In CustomTestUserGroupCallbackImpl Checking Group exists Group:"+groupId+":Result:"+retVal);
		return retVal;
	}

	
	@Override
	public boolean existsUser(String userId) {
		LOGGER.info("CustomTestUserGroupCallbackImpl # existsUser() is called, user:"+userId);
		
		boolean retVal = false;
		
		//We always need Administrator as User for jBPM
		if (userId.equals("Administrator")){
			retVal = true;
			return retVal;
		}
		
		if (userId != null && !userId.trim().equals("")) {
			for (String str: userList) {
				if (str.trim().contains(userId)) {
					retVal = true;
				}
			}
		}
		LOGGER.info("In CustomTestUserGroupCallbackImpl Checking User exists User:"+userId+":Result:"+retVal);
		return retVal;
	}
	
	// Although we return false for user "root" existsUser() method
	// here we return a group id for this user to reproduce the scenario which customer is trying...
	@Override
	public List<String> getGroupsForUser(String userId, List<String> groupIds,
			List<String> allExistingGroupIds) {
		
		
		LOGGER.info("CustomTestUserGroupCallbackImpl # getGroupsForUser() is called, user:"+userId);
	    
		ArrayList<String> rtnGroupIDs = new ArrayList<String>();
		if (userId.equals("bpmsAdmin") || userId.equals("root")) {
			rtnGroupIDs = new ArrayList<String>(groupList);
		} else {
			
		}
		return rtnGroupIDs;
	}

}
